package com.example.getweather.entity;

import lombok.*;

import java.sql.Timestamp;

/**
 * 和风天气数据(小时)
 */
@Data
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class HeFengHour {

    private Timestamp ts;
    //温度,默认单位：摄氏度
    private float temp;
    /**
     * 国标码
     */
    private String areaCode;
    //天气状况的文字描述，包括阴晴雨雪等天气状态的描述
    private String text;
    //风向
    private String windDir;
    //风向360角度
    private float wind360;
    //风速,公里/小时
    private float windSpeed;
    //风速,米/秒
    private float windSpeedM;
    //风力等级
    private float windScale;
    //云量，百分比数值。可能为空
    private float cloud;
    //当前小时累计降水量，默认单位：毫米
    private float precip;
    //露点温度。可能为空
    private float dew;
    //相对湿度
    private float humidity;
    //地面气压 彩云接口
    private float pressure;
    //向下短波辐射通量(W/M2) 彩云接口
    private float dswrf;


}
