package com.example.getweather.util;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;

@Service
public class WeixinPush {
    private static final String CORP_ID = "ww4248d74a47dc9aef";
    private static final String SECRET = "rN0Nf7VIHZLO-nHNRvjJ_yAwiNfbEHED8t6Z8UcR0FU";
    private static final String ACCESS_TOKEN_URL = "https://qyapi.weixin.qq.com/cgi-bin/gettoken";
    private static final String SEND_MESSAGE_URL = "https://qyapi.weixin.qq.com/cgi-bin/message/send";

    public static void main(String[] args) throws Exception {
        WeixinPush weixinPush = new WeixinPush();
        //WeixinMessage weixinMessage = new WeixinMessage();
        // weixinMessage.setToUser("WangHongChen|XiuWei|DouZhi");
        //weixinMessage.setContent(DateUtil.today() + "日 电力交易系统在获取天气数据时报错, 彩云天气API 额度已用尽");
        //weixinMessage.setMsgType("markdown");
        //weixinMessage.setAgentid(1000009); // 确保 agentid 正确

        String alarm = "电力交易系统在获取天气数据时报错, 彩云天气API 额度已用尽";
        String description = "接口调用异常";


        weixinPush.sendMessageBot(alarm, description);
    }

    public String getAccessToken() throws Exception {
        String url = ACCESS_TOKEN_URL + "?corpid=" + CORP_ID + "&corpsecret=" + SECRET;
        HttpURLConnection connection = (HttpURLConnection) new URL(url).openConnection();
        connection.setRequestMethod("GET");

        BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream(), StandardCharsets.UTF_8));
        StringBuilder response = new StringBuilder();
        String line;
        while ((line = reader.readLine()) != null) {
            response.append(line);
        }
        reader.close();

        // Parse the access_token value from response
        String token = JSON.parseObject(response.toString()).getString("access_token");
        return token;
    }

    public void sendMessage(WeixinMessage message) throws Exception {
        String accessToken = getAccessToken();

        String url = SEND_MESSAGE_URL + "?access_token=" + accessToken;
        CloseableHttpClient httpClient = HttpClients.createDefault();
        HttpPost post = new HttpPost(url);
        post.setHeader("Content-Type", "application/json; charset=UTF-8"); // 指定字符编码

        StringEntity entity = new StringEntity(message.toJson(), "UTF-8"); // 指定字符编码
        post.setEntity(entity);

        String response = EntityUtils.toString(httpClient.execute(post).getEntity(), "UTF-8"); // 指定字符编码
        System.out.println("已将消息发送到企业微信: " + response);
        httpClient.close();
    }

    public void sendMessageBot(String alarm, String description) throws Exception {
        // 消息模板
        String msgTemp = "电力交易系统气象数据接入提醒：\n" +
                "<font color=\"comment\">{}</font>\n" +
                "{}" +
                "\n" +
                "抄送：{} \n";
        // 内容模板
        String substanceTemp = "    ><font color=\"warning\">{}</font> \n" +
                "事件描述：<font color=\"warning\">{}</font> \n" +
                "{}";
        //String http = "[彩云开放平台](https://platform.caiyunapp.com/login?redirect=/dashboard/index)";
        //String alarm = "电力交易系统在获取天气数据时报错, 彩云天气API 额度已用尽";
        //String description = "接口调用异常";
        String sb = StrUtil.format(substanceTemp, alarm, description, "");

        StringBuilder ccp = new StringBuilder();
        ccp.append("<@WangHongChen> ");
        ccp.append("<@XiuWei> ");
        ccp.append("<@DouZhi> ");
        String content = StrUtil.format(msgTemp, DateUtil.today(), sb, ccp);
        JSONObject markdown = new JSONObject();
        markdown.put("content", content);
        JSONObject reqBody = new JSONObject();
        reqBody.put("msgtype", "markdown");
        reqBody.put("markdown", markdown);
        reqBody.put("safe", 0);


        String url = "https://qyapi.weixin.qq.com/cgi-bin/webhook/send?key=bb68a074-8600-4891-b944-cc993e3cf158&debug=1";
        CloseableHttpClient httpClient = HttpClients.createDefault();
        HttpPost post = new HttpPost(url);
        post.setHeader("Content-Type", "application/json; charset=UTF-8"); // 指定字符编码

        StringEntity entity = new StringEntity(reqBody.toJSONString(), "UTF-8"); // 指定字符编码
        post.setEntity(entity);

        String response = EntityUtils.toString(httpClient.execute(post).getEntity(), "UTF-8"); // 指定字符编码
        System.out.println("已将消息发送到企业微信机器人: " + response);
        httpClient.close();
    }
}
